%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?pyver: %global pyver %(%{__python} -c "import sys ; print sys.version[:3]")}

%global modname autocloud


Name:           autocloud
Version:        0.7.1
Release:        3%{?dist}
Summary:        A test framework to test Fedora cloud images
Group:          Applications/Internet
License:        GPLv3
URL:            http://github.com/kushaldas/autocloud
Source0:        http://pypi.python.org/packages/source/t/autocloud/autocloud-%{version}.tar.gz

BuildArch:      noarch

BuildRequires:  python2-devel
BuildRequires:  python-setuptools
BuildRequires:  fedmsg
BuildRequires:  python-sqlalchemy
BuildRequires:  python-redis
BuildRequires:  python-retask
BuildRequires:  python-sqlalchemy-utils
BuildRequires:  python-flask
BuildRequires:  systemd

%description
A test framework which automatically downloads and tests Fedora cloud image
builds from koji.

%package common
Summary: Autocloud common library

Requires: python-psycopg2

%description common
This package contains the common libraries required by other autocloud
components.

%package web
Summary: A REST API server on top of statscache

Requires: %{name}-common = %{version}-%{release}
Requires: python-flask
Requires: httpd
Requires: mod_wsgi

%description web
This package is for web interface for autocloud.

%package backend
Summary: Autocloud backend
Requires: %{name}-common = %{version}-%{release}
Requires: fedmsg-hub
Requires: tunir
Requires: python-sqlalchemy
Requires: python-redis
Requires: python-retask
Requires: python-sqlalchemy-utils
Requires: redis
Requires: fedmsg
Requires: koji
Requires: python-alembic
Requires: python-requests
Requires: python2-fedfind


%description backend
This runs a daemon which keeps listening to fedmsg and dispatches messages
to autocloud service for process images.


%prep
%setup -q -n %{name}-%{version}

%build
%{__python} setup.py build

%install
%{__python} setup.py install -O1 --skip-build \
    --install-data=%{_datadir} --root %{buildroot}

%{__mkdir_p} %{buildroot}%{_sysconfdir}/fedmsg.d/
%{__cp} fedmsg.d/autocloud.py %{buildroot}%{_sysconfdir}/fedmsg.d/.
%{__cp} fedmsg.d/endpoints-autocloud.py %{buildroot}%{_sysconfdir}/fedmsg.d/.

%{__mkdir_p} %{buildroot}%{_datadir}/%{modname}/
%{__mkdir_p} %{buildroot}/%{_sysconfdir}/httpd/conf.d
install -m 644 apache/%{modname}.wsgi %{buildroot}%{_datadir}/%{modname}/%{modname}.wsgi
install -m 644 apache/%{modname}.conf %{buildroot}%{_sysconfdir}/httpd/conf.d/%{modname}.conf
install -m 644 autocloud_job.py %{buildroot}%{_datadir}/%{modname}/autocloud_job.py
install -m 644 createdb.py %{buildroot}%{_datadir}/%{modname}/createdb.py
mv autocloud/web/static/ %{buildroot}%{_datadir}/%{modname}

%{__mkdir_p} %{buildroot}%{_sbindir}
install -m 755 autocloud_job %{buildroot}%{_sbindir}/autocloud_job
install -m 755 kill_vagrant %{buildroot}%{_sbindir}/kill_vagrant

mkdir -p %{buildroot}%{_sysconfdir}/%{modname}/
install -m 644 config/%{modname}.cfg %{buildroot}%{_sysconfdir}/%{modname}/%{modname}.cfg

%{__mkdir_p} %{buildroot}%{_unitdir}
%{__install} -pm644 autocloud.service \
%{buildroot}%{_unitdir}/autocloud.service

rm -rf %{buildroot}%{_datadir}/%{modname}/static/bootstrap

# Install the alembic configuration file
install -m 644 alembic.ini $RPM_BUILD_ROOT/%{_sysconfdir}/%{modname}/alembic.ini
# Install the alembic revisions
cp -r alembic $RPM_BUILD_ROOT/%{_datadir}/autocloud

%files common
%doc README.md
%license LICENSE
%dir %{python_sitelib}/%{modname}/
%dir %{_sysconfdir}/%{modname}/
%dir %{_datadir}/%{modname}
%{python_sitelib}/%{modname}/__init__.py*
%{python_sitelib}/%{modname}/models.py*
%{python_sitelib}/%{modname}/constants.py*
%{python_sitelib}/%{modname}/utils/*
%{python_sitelib}/%{modname}-%{version}-py%{pyver}.egg-info/
%{_datadir}/%{modname}/alembic/*
%config(noreplace) %{_sysconfdir}/fedmsg.d/autocloud.py*
%config(noreplace) %{_sysconfdir}/fedmsg.d/endpoints-autocloud.py*
%config(noreplace) %{_sysconfdir}/%{modname}/%{modname}.cfg
%config(noreplace) %{_sysconfdir}/%{modname}/alembic.ini
%{_datadir}/%{modname}/createdb.py*

%files web
%{python_sitelib}/%{modname}/web/*
%{_datadir}/%{modname}/%{modname}.wsgi
%{_datadir}/%{modname}/static/*
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{modname}.conf

%files backend
%{python_sitelib}/%{modname}/consumer.py*
%{python_sitelib}/%{modname}/producer.py*
%{_datadir}/%{modname}/autocloud_job.py*
%{_sbindir}/autocloud_job
%{_sbindir}/kill_vagrant
%{_unitdir}/autocloud.service


%changelog
* Thu Jun 22 2017 Sayan Chowdhury <sayanchowdhury@fedoraproject.org> - 0.7.1-3
- Add python2-fedfind

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Oct 26 2016 Sayan Chowdhury <sayanchowdhury@fedoraproject.org> - 0.7.1-1
- updates to 0.7.1

* Wed Oct 26 2016 Sayan Chowdhury <sayanchowdhury@fedoraproject.org> - 0.7.0-1
- updates to 0.7.0

* Tue Jul 19 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.1-2
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages

* Mon Jul 18 2016 Kushal Das <kushal@fedoraproject.org> - 0.6.1-1
- updates to 0.6.1

* Fri Jul 15 2016 Kushal Das <kushal@fedoraproject.org> - 0.6-1
- updates to 0.6

* Mon Jun 27 2016 Kushal Das <kushal@fedoraproject.org> - 0.5-1
- updates to 0.5

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Oct 8 2015 Kushal Das <kushal@fedoraproject.org> - 0.4-1
- Fixes changelog date, updates to 0.4

* Thu Oct 8 2015 Kushal Das <kushal@fedoraproject.org> - 0.3-3
- builds with proper source.

* Thu Oct 8 2015 Kushal Das <kushal@fedoraproject.org> - 0.3-2
- Updates to 0.3

* Thu Oct 8 2015 Kushal Das <kushal@fedoraproject.org> - 0.3-1
- Updates to 0.3

* Wed Sep 30 2015 Kushal Das <kushal@fedoraproject.org> - 0.2-1
- Updates to 0.2

* Mon Sep 28 2015 Kushal Das <kushal@fedoraproject.org> - 0.1-5
- Getting deployment ready

* Wed Sep 23 2015 Praveen Kumar <kumarpraveen.nitdgp@gmail.com> 0.1-4
- Add createdb to proper location
- Remove db creation during rpmbuild

* Wed Sep 23 2015 Kushal Das <kushal@fedoraproject.org> - 0.1-3
- Fixes dependencies

* Tue Sep 22 2015 Ratnadeep Debnath <rtnpro@gmail.com> - 0.1-2
- Updating SPEC based on suggestions from review request.

* Mon Aug 31 2015 Ratnadeep Debnath <rtnpro@gmail.com> - 0.1-1
- Initial packaging.
